Subject: RE: [Tsvwg] Re: Must SCTP data chunks be in TSN order?

From: Jon Berger <[email-masked]>
Date: Fri, 22 Jun 2001 09:12:39 +0100

Well the receiver can do what they like (ABORT, ignore, do what they think
the peer wanted) because the sender is not obeying the protocol.  If there
is no reason to allow a sender to send in a bizarre order, why place
additional cost on the receiver?

I think the MUST should stay.

Jon

-----Original Message-----
From: Qiaobing Xie [mailto:[email-masked]]
Sent: 22 June 2001 00:01
To: Jon Berger
Cc: Qiaobing Xie; La Monte H.P. Yarroll; [email-masked];
[email-masked]
Subject: Re: [Tsvwg] Re: Must SCTP data chunks be in TSN order?

Hmmm, a surprise to me. This must have been an addition from the final
stage during the RFC editing.

Now, is there any implementation enforcing this "MUST" on the receiver
side? Or is every receiver just processing the arrived packets with
total trust that its peer data sender always puts TSNs in order?

I'd think a "SHOULD" here is better. 

If we want to keep the "MUST", then we need to clarify what the receiver
should do if a packet showed up with a bad TSN order.

-Qiaobing 

Jon Berger wrote:
> 
> RFC2960 section  6.10:
> "The transmitter MUST transmit DATA chunks within a SCTP packet in
> increasing order of TSN."
> 
> Jon
> 
> -----Original Message-----
> From: Qiaobing Xie [mailto:[email-masked]]
> Sent: 20 June 2001 22:59
> To: La Monte H.P. Yarroll
> Cc: [email-masked]; [email-masked]
> Subject: [Tsvwg] Re: Must SCTP data chunks be in TSN order?
> 
> La Monte,
> 
> See my comments below...
> 
> "La Monte H.P. Yarroll" wrote:
> >
> > Are SCTP DATA chunks bundled in a single packet required to be in TSN
> > order?  I can't find a mention of the topic in RFC 2960.  I vaguely
> > recall a discussion suggesting that they ought to be in ascending TSN
> > order, but that it is not required.
> >
> > If they are NOT required to be in ascending TSN order, then we have
> > some bothersome extra code to write for ECN:
> 
> So, you won't mind adding code to check whether TSNs are in ascending
> order in *every* received packet and adding yet more code to reporting
> any ordering violation?
> 
> I think the code you would need to add to enforce the new rule would be
> many many times more than tracking the LOWEST TSN in your ECN
> subroutine.
> 
> -Qiaobing
> 
> >
> > Appendix A:
> >
> >    ECN-Echo:
> >
> >    RFC 2481 details a specific bit for a receiver to send back in its
> >    TCP acknowledgements to notify the sender of the Congestion
> >    Experienced (CE) bit having arrived from the network.  For SCTP this
> >    same indication is made by including the ECNE chunk.  This chunk
> >    contains one data element, i.e. the lowest TSN associated with the IP
> >    datagram marked with the CE bit, and looks as follows:
> >
> > In other words, we have to find the LOWEST TSN in the whole packet.
> >
> > For our implementation, we don't really care WHICH TSN we get in an
> > incoming ECNE--we can identify the sending transport based on ANY TSN
> > in the chunk.  What we'd LIKE to do is just report the FIRST TSN in
> > the packet (better yet would be the LAST TSN).  How immutable is this?
> > |
> |
> > |
> |
> > ---------------------- Mailing List commands
> --------------------------------
> > Send the following in the body of a message to
> [email-masked]
> > SUBSCRIBE TO LIST    : subscribe list-name   | LIST OF LISTS   : lists
> > UNSUBSCRIBE TO LIST  : unsubscribe list-name | RETRIEVE HELP   : help
> > WHO ON ON THE LIST   : who list-name         | GET DESCRIPTION : info
> list-name
> > |
> |
> > Or you can use http://majordomo.cig.mot.com
> >
>
----------------------------------------------------------------------------
> --
> 
> _______________________________________________
> tsvwg mailing list
> [email-masked]
> http://www1.ietf.org/mailman/listinfo/tsvwg
> |
|
> |
|
> ---------------------- Mailing List commands
--------------------------------
> Send the following in the body of a message to
[email-masked]
> SUBSCRIBE TO LIST    : subscribe list-name   | LIST OF LISTS   : lists
> UNSUBSCRIBE TO LIST  : unsubscribe list-name | RETRIEVE HELP   : help
> WHO ON ON THE LIST   : who list-name         | GET DESCRIPTION : info
list-name
> |
|
> Or you can use http://majordomo.cig.mot.com
>
----------------------------------------------------------------------------
--

_______________________________________________
tsvwg mailing list
[email-masked]
http://www1.ietf.org/mailman/listinfo/tsvwg

_______________________________________________
tsvwg mailing list
[email-masked]
http://www1.ietf.org/mailman/listinfo/tsvwg